// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rmf_task_msgs:action/DynamicEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/action/dynamic_event.h"


#ifndef RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_H_
#define RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'EVENT_TYPE_UNINITIALIZED'.
/**
  * Default value for event_type, indicates that the message was default-initialized.
  * This will immediately be rejected by the action server.
 */
enum
{
  rmf_task_msgs__action__DynamicEvent_Goal__EVENT_TYPE_UNINITIALIZED = 0ul
};

/// Constant 'EVENT_TYPE_NEXT'.
/**
  * Indicates that this request describes the next event for the phase to execute.
 */
enum
{
  rmf_task_msgs__action__DynamicEvent_Goal__EVENT_TYPE_NEXT = 1ul
};

/// Constant 'EVENT_TYPE_CANCEL'.
/**
  * Cancel the currently active event. The id field must match the ID of the ID of
  * the currently active event.
 */
enum
{
  rmf_task_msgs__action__DynamicEvent_Goal__EVENT_TYPE_CANCEL = 2ul
};

/// Constant 'EVENT_TYPE_FINISHED'.
/**
  * Indicates that the dynamic events are finished. After this, no more event commands can
  * be sent until a new Dynamic Event begins.
 */
enum
{
  rmf_task_msgs__action__DynamicEvent_Goal__EVENT_TYPE_FINISHED = 3ul
};

// Include directives for member types
// Member 'category'
// Member 'description'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_Goal
{
  /// The sequence number for this dynamic event. This is unique for each run of a
  /// dynamic event within one robot. It must match the dynamic_event_seq field in
  /// the DynamicEventDescription which describes the event that is being executed.
  ///
  /// Each new run of a dynamic event for a robot will increment this value until it
  /// reaches integer overflow and goes back to 0.
  uint32_t dynamic_event_seq;
  /// What kind of event is this action commanding. Must be one of the following:
  /// * EVENT_TYPE_NEXT
  /// * EVENT_TYPE_CANCEL
  /// * EVENT_TYPE_FINISHED
  ///
  /// Any other value will be rejected by the action server.
  uint32_t event_type;
  /// Used to specify the category of the event when event_type is EVENT_TYPE_NEXT.
  /// Otherwise this is unused.
  rosidl_runtime_c__String category;
  /// Used to describe the event when event_type is EVENT_TYPE_NEXT.
  /// Otherwise this is unused.
  rosidl_runtime_c__String description;
  /// When using EVENT_TYPE_NEXT, this will be the ID for the newly created event.
  ///
  /// When using EVENT_TYPE_CANCEL, this indicates the ID of the event that is supposed to
  /// be cancelled. If it does not match the currently active event ID, then the request will be
  /// rejected. If it does match, then the action response will be sent once the event has
  /// finished its cancellation.
  uint64_t id;
  /// If this value is greater than 0.0, then the robot will enter a "stubborn" mode
  /// after the event is finished where it broadcasts its position to the traffic
  /// schedule and behaves like a stubborn negotiator, forcing other robots to wait
  /// on it or reroute.
  ///
  /// The value itself represents the length of time in seconds that the robot will
  /// claim it is remaining at its current location. This signal will be refreshed
  /// every 1.0s. Values less than 2.0 will be treated as 2.0 with a warning because
  /// a stubborn period less than would cause excessive negotiation instability.
  ///
  /// If you can anticipate how long it will be between this command finishing and
  /// the next starting, that time period would be a good value to use here.
  float stubborn_period;
} rmf_task_msgs__action__DynamicEvent_Goal;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_Goal.
typedef struct rmf_task_msgs__action__DynamicEvent_Goal__Sequence
{
  rmf_task_msgs__action__DynamicEvent_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_Goal__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'execution_failure'
// Member 'status'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_Result
{
  /// An error string that will describe a critical issue that occurred while attempting
  /// to begin execution of the action, such as:
  /// * a race condition occurs where multiple action requests are submitted simultaneously
  ///   for the same robot and both are accepted before either begins
  /// * a request is sent while the fleet adapter is shutting down
  /// * an error occurs while generating the
  ///
  /// If this string is empty then no error occurred while beginning execution.
  /// If this string is non-empty then the remaining fields in this message will be
  /// default-initialized.
  rosidl_runtime_c__String execution_failure;
  /// The last status of the action before it was finished
  rosidl_runtime_c__String status;
  /// The ID of the event which has finished
  uint64_t id;
} rmf_task_msgs__action__DynamicEvent_Result;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_Result.
typedef struct rmf_task_msgs__action__DynamicEvent_Result__Sequence
{
  rmf_task_msgs__action__DynamicEvent_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_Result__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'status'
// already included above
// #include "rosidl_runtime_c/string.h"
// Member 'logs'
#include "rmf_task_msgs/msg/detail/log_entry__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_Feedback
{
  /// Current status of the action. This string will match one of the values in the "status" schema:
  /// https://github.com/open-rmf/rmf_api_msgs/rmf_api_msgs/schemas/task_state.json
  rosidl_runtime_c__String status;
  /// The ID of the currently active event.
  uint64_t id;
  /// Log messages that have occurred since the last feedback message.
  rmf_task_msgs__msg__LogEntry__Sequence logs;
} rmf_task_msgs__action__DynamicEvent_Feedback;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_Feedback.
typedef struct rmf_task_msgs__action__DynamicEvent_Feedback__Sequence
{
  rmf_task_msgs__action__DynamicEvent_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_Feedback__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "rmf_task_msgs/action/detail/dynamic_event__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  rmf_task_msgs__action__DynamicEvent_Goal goal;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Request;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_SendGoal_Request.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence
{
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Response;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_SendGoal_Response.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence
{
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event__response__MAX_SIZE = 1
};

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rmf_task_msgs__action__DynamicEvent_SendGoal_Request__Sequence request;
  rmf_task_msgs__action__DynamicEvent_SendGoal_Response__Sequence response;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Event;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_SendGoal_Event.
typedef struct rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence
{
  rmf_task_msgs__action__DynamicEvent_SendGoal_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_SendGoal_Event__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} rmf_task_msgs__action__DynamicEvent_GetResult_Request;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_GetResult_Request.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence
{
  rmf_task_msgs__action__DynamicEvent_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Response
{
  int8_t status;
  rmf_task_msgs__action__DynamicEvent_Result result;
} rmf_task_msgs__action__DynamicEvent_GetResult_Response;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_GetResult_Response.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence
{
  rmf_task_msgs__action__DynamicEvent_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rmf_task_msgs__action__DynamicEvent_GetResult_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rmf_task_msgs__action__DynamicEvent_GetResult_Event__response__MAX_SIZE = 1
};

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rmf_task_msgs__action__DynamicEvent_GetResult_Request__Sequence request;
  rmf_task_msgs__action__DynamicEvent_GetResult_Response__Sequence response;
} rmf_task_msgs__action__DynamicEvent_GetResult_Event;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_GetResult_Event.
typedef struct rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence
{
  rmf_task_msgs__action__DynamicEvent_GetResult_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_GetResult_Event__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "rmf_task_msgs/action/detail/dynamic_event__struct.h"

/// Struct defined in action/DynamicEvent in the package rmf_task_msgs.
typedef struct rmf_task_msgs__action__DynamicEvent_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  rmf_task_msgs__action__DynamicEvent_Feedback feedback;
} rmf_task_msgs__action__DynamicEvent_FeedbackMessage;

// Struct for a sequence of rmf_task_msgs__action__DynamicEvent_FeedbackMessage.
typedef struct rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence
{
  rmf_task_msgs__action__DynamicEvent_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__action__DynamicEvent_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RMF_TASK_MSGS__ACTION__DETAIL__DYNAMIC_EVENT__STRUCT_H_
