// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rmf_task_msgs:msg/DynamicEventStatus.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rmf_task_msgs/msg/dynamic_event_status.h"


#ifndef RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_H_
#define RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'DYNAMIC_STATE_INACTIVE'.
/**
  * There is no dynamic event running right now. Any DynamicEvent action requests
  * will be rejected in this state.
 */
enum
{
  rmf_task_msgs__msg__DynamicEventStatus__DYNAMIC_STATE_INACTIVE = 0
};

/// Constant 'DYNAMIC_STATE_WAITING'.
/**
  * The dynamic event is waiting for its next command. In this state it would be
  * valid to issue a DynamicEvent action request.
 */
enum
{
  rmf_task_msgs__msg__DynamicEventStatus__DYNAMIC_STATE_WAITING = 1
};

/// Constant 'DYNAMIC_STATE_RUNNING'.
/**
  * The dynamic event is running a command right now. Any DynamicEvent action
  * requests will be rejected in this state.
 */
enum
{
  rmf_task_msgs__msg__DynamicEventStatus__DYNAMIC_STATE_RUNNING = 2
};

// Include directives for member types
// Member 'status'
#include "rosidl_runtime_c/string.h"
// Member 'time'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in msg/DynamicEventStatus in the package rmf_task_msgs.
/**
  * Published to the topic
  * rmf/dynamic_event/status/<fleet_name>/<robot_name>
 */
typedef struct rmf_task_msgs__msg__DynamicEventStatus
{
  /// The sequence number for this dynamic event. This is unique for each run of a
  /// dynamic event within one robot.
  ///
  /// Each new run of a dynamic event for a robot will increment this value until it
  /// reaches integer overflow and goes back to 0.
  uint32_t dynamic_event_seq;
  /// Current state of dynamic event execution for the robot associated with the
  /// topic that this is being published to.
  uint8_t dynamic_state;
  /// If the dynamic_state is DYNAMIC_STATE_RUNNING, then this will be the current
  /// status of the action. This string will match one of the values in the "status" schema:
  /// https://github.com/open-rmf/rmf_api_msgs/rmf_api_msgs/schemas/task_state.json
  rosidl_runtime_c__String status;
  /// If the dynamic_state is DYNAMIC_STATE_RUNNING, then this will be The ID of the
  /// current sub-event within the dynamic event.
  uint64_t id;
  /// Timestamp for when this status change occurred.
  builtin_interfaces__msg__Time time;
} rmf_task_msgs__msg__DynamicEventStatus;

// Struct for a sequence of rmf_task_msgs__msg__DynamicEventStatus.
typedef struct rmf_task_msgs__msg__DynamicEventStatus__Sequence
{
  rmf_task_msgs__msg__DynamicEventStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rmf_task_msgs__msg__DynamicEventStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RMF_TASK_MSGS__MSG__DETAIL__DYNAMIC_EVENT_STATUS__STRUCT_H_
