# generated from rosidl_generator_py/resource/_idl.py.em
# with input from rmf_task_msgs:msg/LogEntry.idl
# generated code does not contain a copyright notice

# This is being done at the module level and not on the instance level to avoid looking
# for the same variable multiple times on each instance. This variable is not supposed to
# change during runtime so it makes sense to only look for it once.
from os import getenv

ros_python_check_fields = getenv('ROS_PYTHON_CHECK_FIELDS', default='')


# Import statements for member types

import builtins  # noqa: E402, I100

import rosidl_parser.definition  # noqa: E402, I100


class Metaclass_LogEntry(type):
    """Metaclass of message 'LogEntry'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
        'TIER_UNINITIALIZED': 'uninitialized',
        'TIER_INFO': 'info',
        'TIER_WARNING': 'warning',
        'TIER_ERROR': 'error',
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('rmf_task_msgs')
        except ImportError:
            import logging
            import traceback
            logger = logging.getLogger(
                'rmf_task_msgs.msg.LogEntry')
            logger.debug(
                'Failed to import needed modules for type support:\n' +
                traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg__log_entry
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg__log_entry
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg__log_entry
            cls._TYPE_SUPPORT = module.type_support_msg__msg__log_entry
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg__log_entry

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
            'TIER_UNINITIALIZED': cls.__constants['TIER_UNINITIALIZED'],
            'TIER_INFO': cls.__constants['TIER_INFO'],
            'TIER_WARNING': cls.__constants['TIER_WARNING'],
            'TIER_ERROR': cls.__constants['TIER_ERROR'],
        }

    @property
    def TIER_UNINITIALIZED(self):
        """Message constant 'TIER_UNINITIALIZED'."""
        return Metaclass_LogEntry.__constants['TIER_UNINITIALIZED']

    @property
    def TIER_INFO(self):
        """Message constant 'TIER_INFO'."""
        return Metaclass_LogEntry.__constants['TIER_INFO']

    @property
    def TIER_WARNING(self):
        """Message constant 'TIER_WARNING'."""
        return Metaclass_LogEntry.__constants['TIER_WARNING']

    @property
    def TIER_ERROR(self):
        """Message constant 'TIER_ERROR'."""
        return Metaclass_LogEntry.__constants['TIER_ERROR']


class LogEntry(metaclass=Metaclass_LogEntry):
    """
    Message class 'LogEntry'.

    Constants:
      TIER_UNINITIALIZED
      TIER_INFO
      TIER_WARNING
      TIER_ERROR
    """

    __slots__ = [
        '_seq',
        '_tier',
        '_unix_millis_time',
        '_text',
        '_check_fields',
    ]

    _fields_and_field_types = {
        'seq': 'uint32',
        'tier': 'string',
        'unix_millis_time': 'int64',
        'text': 'string',
    }

    # This attribute is used to store an rosidl_parser.definition variable
    # related to the data type of each of the components the message.
    SLOT_TYPES = (
        rosidl_parser.definition.BasicType('uint32'),  # noqa: E501
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
        rosidl_parser.definition.BasicType('int64'),  # noqa: E501
        rosidl_parser.definition.UnboundedString(),  # noqa: E501
    )

    def __init__(self, **kwargs):
        if 'check_fields' in kwargs:
            self._check_fields = kwargs['check_fields']
        else:
            self._check_fields = ros_python_check_fields == '1'
        if self._check_fields:
            assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
                'Invalid arguments passed to constructor: %s' % \
                ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.seq = kwargs.get('seq', int())
        self.tier = kwargs.get('tier', str())
        self.unix_millis_time = kwargs.get('unix_millis_time', int())
        self.text = kwargs.get('text', str())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = []
        for s, t in zip(self.get_fields_and_field_types().keys(), self.SLOT_TYPES):
            field = getattr(self, s)
            fieldstr = repr(field)
            # We use Python array type for fields that can be directly stored
            # in them, and "normal" sequences for everything else.  If it is
            # a type that we store in an array, strip off the 'array' portion.
            if (
                isinstance(t, rosidl_parser.definition.AbstractSequence) and
                isinstance(t.value_type, rosidl_parser.definition.BasicType) and
                t.value_type.typename in ['float', 'double', 'int8', 'uint8', 'int16', 'uint16', 'int32', 'uint32', 'int64', 'uint64']
            ):
                if len(field) == 0:
                    fieldstr = '[]'
                else:
                    if self._check_fields:
                        assert fieldstr.startswith('array(')
                    prefix = "array('X', "
                    suffix = ')'
                    fieldstr = fieldstr[len(prefix):-len(suffix)]
            args.append(s + '=' + fieldstr)
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.seq != other.seq:
            return False
        if self.tier != other.tier:
            return False
        if self.unix_millis_time != other.unix_millis_time:
            return False
        if self.text != other.text:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        from copy import copy
        return copy(cls._fields_and_field_types)

    @builtins.property
    def seq(self):
        """Message field 'seq'."""
        return self._seq

    @seq.setter
    def seq(self, value):
        if self._check_fields:
            assert \
                isinstance(value, int), \
                "The 'seq' field must be of type 'int'"
            assert value >= 0 and value < 4294967296, \
                "The 'seq' field must be an unsigned integer in [0, 4294967295]"
        self._seq = value

    @builtins.property
    def tier(self):
        """Message field 'tier'."""
        return self._tier

    @tier.setter
    def tier(self, value):
        if self._check_fields:
            assert \
                isinstance(value, str), \
                "The 'tier' field must be of type 'str'"
        self._tier = value

    @builtins.property
    def unix_millis_time(self):
        """Message field 'unix_millis_time'."""
        return self._unix_millis_time

    @unix_millis_time.setter
    def unix_millis_time(self, value):
        if self._check_fields:
            assert \
                isinstance(value, int), \
                "The 'unix_millis_time' field must be of type 'int'"
            assert value >= -9223372036854775808 and value < 9223372036854775808, \
                "The 'unix_millis_time' field must be an integer in [-9223372036854775808, 9223372036854775807]"
        self._unix_millis_time = value

    @builtins.property
    def text(self):
        """Message field 'text'."""
        return self._text

    @text.setter
    def text(self, value):
        if self._check_fields:
            assert \
                isinstance(value, str), \
                "The 'text' field must be of type 'str'"
        self._text = value
